// soln.h
//


typedef struct cluestruct
{
 int  x;                     /* coords of clue                     */
 int  y;
 int  dcdata;                /* location in dictionary of solution */
 char down;                  /* does it run down ?                 */
 char len;                   /* length of text                     */
} cluestruct;


#define MAXCLUE 256




extern cluestruct cluestr[MAXCLUE];      /* big list of things to solve */



#define SSTRLEN 36


typedef struct wrdstr
{
 int  x;                     /* coords of start                    */
 int  y;
 int  dx;                    /* direction */
 int  dy;
 int  selected;
 char text[SSTRLEN];          /* string */
} wrdstr;


extern char * sbuffer;


extern int        nextclue(char * string,int clue);
extern void       gridgetstring(int clue,char * string);
extern os_error * addsolution(int dcdata,int word);
extern os_error * addsquaresolution(int x,int y,int dx,int dy,char * string);
extern void       fillinstring(int clue,char * string);
extern void       blanksolutions(void);
extern void       clearsquaresolnscoords(void);
extern void       clearsolutions(void);
extern os_error * updatesolutions(void);
extern int        nselectedsquare(void);
extern void       opensol(void);
extern void       refreshsols(void);
extern os_error * setsolextent(void);
extern os_error * delselection(void);
extern os_error * addusersquaresolution(void);
extern os_error * solvesquare(void);

extern os_error * solution(void);
extern os_error * anagram(void);


extern os_error * solninit(int mainhandle);

